﻿using System.Collections;
using System.Collections.Generic;
using System.Collections.ObjectModel;
using Xunit;
using Should;

namespace AutoMapper.UnitTests.Bug
{
    public class EFCollections : AutoMapperSpecBase
    {
        private Dest _dest;

        public class Source
        {
            public ICollection<Child> Children { get; set; }

        }

        public class _Source : Source
        {
        }

        public class _Child : Child
        {

        }

        public class Dest
        {
            public ICollection<DestChild> Children { get; set; } 
        }

        public class DestChild {}

        protected override void Establish_context()
        {
            Mapper.Initialize(cfg =>
            {
                cfg.CreateMap<Source, Dest>();
                cfg.CreateMap<Child, DestChild>();
            });
        }

        protected override void Because_of()
        {
            var source = new _Source
            {
                Children = new Collection<Child>
                {
                    new _Child(),
                    new _Child()
                }
            };
            _dest = Mapper.Map<Source, Dest>(source);
        }

        [Fact]
        public void Should_map_collection_items()
        {
            _dest.Children.Count.ShouldEqual(2);
        }
    }
}
